FQ.MD.WEB/ViewModels/Form/RoleForms.cs
using FQ.MD.WEB.Resources;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;

namespace FQ.MD.WEB.ViewModels.Form
{
    public class RoleAddForm
    {
        [Required(ErrorMessageResourceType = typeof(Res), ErrorMessageResourceName = "ValidationRequired")]
        public string Role { get; set; }
        [Required(ErrorMessageResourceType = typeof(Res), ErrorMessageResourceName = "ValidationRequired")]
        public string Description { get; set; }
        public bool IsActive { get; set; }
    }

    public class RoleEditForm
    {
        public int RoleId { get; set; }
        [Required(ErrorMessageResourceType = typeof(Res), ErrorMessageResourceName = "ValidationRequired")]
        public string Role { get; set; }
        [Required(ErrorMessageResourceType = typeof(Res), ErrorMessageResourceName = "ValidationRequired")]
        public string Description { get; set; }
        public bool IsActive { get; set; }
    }

    public class RoleDeleteForm
    {
        public int RoleId { get; set; }
        public string Role { get; set; }
        public string Description { get; set; }
        public bool IsActive { get; set; }
        [Required(ErrorMessageResourceType = typeof(Res), ErrorMessageResourceName = "ValidationRequired")]
        public string Remark { get; set; }
    }
}

FQ.MD.WEB/ViewModels/RoleViewModels.cs
using FQ.MD.WEB.Resources;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;

namespace FQ.MD.WEB.ViewModels
{
    public class RoleViewModel
    {
        public int RoleId { get; set; }
        public string Role { get; set; }
        public string Description { get; set; }

        public string Active { get; set; }
        public string Actions { get; set; }

    }

    public class RoleMenuViewModel
    {
        public int Id { get; set; }
        public int RoleId { get; set; }
        public string Role { get; set; }
        public string Description { get; set; }
        public int MenuId { get; set; }
        public int? ParentMenuId { get; set; }
        public string Menu { get; set; }
        public bool IsLink { get; set; }
        public int Sequence { get; set; }
        public string Display { get; set; }

        public string Create { get; set; }
        public string Read { get; set; }
        public string Update { get; set; }
        public string Delete { get; set; }
        public string Sync { get; set; }
        public string Upload { get; set; }
        public string Active { get; set; }
        public string Actions { get; set; }
    }

    public class RoleMenuIndexViewModel
    {
        public int RoleId { get; set; }
        public string Role { get; set; }
        public string Description { get; set; }
        public List<RoleMenuViewModel> Menus { get; set; }
    }
}

FQ.MD.WEB/Controllers/RolesController.cs
using FQ.MD.WEB.ViewModels.JSON;
using FQ.MD.WEB.Helpers;
using FQ.MD.WEB.Models;
using FQ.MD.WEB.Resources;
using FQ.MD.WEB.Services;
using FQ.MD.WEB.ViewModels;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Web;
using System.Web.Mvc;
using FQ.MD.WEB.ViewModels.Form;

namespace FQ.MD.WEB.Controllers
{
    [Authorize]
    public class RolesController : BaseController
    {
        private RoleServices _roleServices = new RoleServices();

        public ActionResult Index()
        {
            return View();
        }

        [HttpPost]
        public JsonResult Index(DataTables model)
        {
            var searchKeywords = !String.IsNullOrEmpty(model.search.value) ? model.search.value.ToLower() : "";

            string sortBy = "Role";
            bool sortDir = true;

            if (model.order != null)
            {
                sortBy = model.columns[model.order[0].column].data;
                sortDir = model.order[0].dir.ToLower() == "asc";
            }

            Expression<Func<GT_MASTER_ROLES, bool>> filter = u => u.Role.ToLower().Contains(searchKeywords) || u.Description.Contains(searchKeywords);
            Func<IQueryable<GT_MASTER_ROLES>, IOrderedQueryable<GT_MASTER_ROLES>> orderBy = q => sortDir ? q.OrderBy(u => u.Role) : q.OrderByDescending(u => u.Role);

            if (sortBy == "Active")
            {
                orderBy = q => sortDir ? q.OrderBy(u => u.IsActive) : q.OrderByDescending(u => u.IsActive);
            }
            if (sortBy == "Description")
            {
                orderBy = q => sortDir ? q.OrderBy(u => u.Description) : q.OrderByDescending(u => u.Description);
            }

            var submenus = new List<ActionsSubmenu>() { new ActionsSubmenu() { SubmenuLabel = "Menus", SubmenuKey = "RoleId", SubmenuController = "RolesMenus" } };

            var models = _roleServices.Get(filter: filter, orderBy: orderBy, skip: model.start, take: model.length)
                .Select(c => new RoleViewModel
                {
                    Role = c.Role,
                    Description = c.Description,
                    Active = DisplayActiveIcon(c.IsActive),
                    Actions = DisplayActions(UserAuthorization, c.RoleId, submenus)
                });

            var totalResultsCount = _roleServices.Get().Count();
            var recordsFiltered = String.IsNullOrEmpty(model.search.value) ? totalResultsCount : _roleServices.Get(filter: filter).Count();

            return Json(new
            {
                draw = model.draw,
                recordsTotal = totalResultsCount,
                recordsFiltered = recordsFiltered,
                data = models.ToList()
            });
        }

        public ActionResult Add()
        {
            return View();
        }

        [HttpPost]
        public ActionResult Add(RoleAddForm form)
        {
            if (ModelState.IsValid)
            {
                var action = _roleServices.AddRole(form, UserAuthorized);
                if (action.IsSuccess)
                {
                    return RedirectToAction("Index");
                }

                var message = DisplayMessage(action.Message, new string[] { "Role" });
                ModelState.AddModelError("", message);
            }

            return View(form);
        }

        public ActionResult Edit(int Id)
        {
            var model = _roleServices.GetRoleById(Id);
            if (model == null)
            {
                return RedirectToAction("Index", "NotFound");
            }

            var form = new RoleEditForm();
            form.RoleId = model.RoleId;
            form.Role = model.Role;
            form.Description = model.Description;
            form.IsActive = model.IsActive;

            return View(form);
        }

        [HttpPost]
        public ActionResult Edit(RoleEditForm form)
        {
            if (ModelState.IsValid)
            {
                var action = _roleServices.UpdateRole(form, UserAuthorized);
                if (action.IsSuccess)
                {
                    return RedirectToAction("Index");
                }
            }

            return View(form);
        }

        public ActionResult Detail(int Id)
        {
            var model = _roleServices.GetRoleById(Id);
            if (model == null)
            {
                return RedirectToAction("Index", "NotFound");
            }

            var viewModel = new RoleViewModel();
            viewModel.RoleId = model.RoleId;
            viewModel.Role = model.Role;
            viewModel.Description = model.Description;
            viewModel.Active = DisplayActiveIcon(model.IsActive);

            return View(viewModel);
        }

        public ActionResult Delete(int Id)
        {
            var model = _roleServices.GetRoleById(Id);
            if (model == null)
            {
                return RedirectToAction("Index", "NotFound");
            }

            var viewModel = new RoleDeleteForm();
            viewModel.RoleId = model.RoleId;
            viewModel.Role = model.Role;
            viewModel.Description = model.Description;
            viewModel.IsActive = model.IsActive;

            return View(viewModel);
        }

        [HttpPost]
        public ActionResult Delete(RoleDeleteForm form)
        {
            if (ModelState.IsValid)
            {
                var action = _roleServices.DeleteRole(form, UserAuthorized);
                if (action.IsSuccess)
                {
                    return RedirectToAction("Index");
                }
            }

            return View(form);
        }
    }
}

FQ.MD.WEB/Views/Roles/Add.cshtml
@model FQ.MD.WEB.ViewModels.Form.RoleAddForm
@using FQ.MD.WEB.Resources

@{
    ViewBag.Title = Res.Add;
}

<nav aria-label="breadcrumb">
    <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="/"><i class="fas fa-home"></i> Dashboard</a></li>
        <li class="breadcrumb-item"><a href="@Url.Action("Index")">@Res.Roles</a></li>
        <li class="breadcrumb-item active" aria-current="page">@ViewBag.Title</li>
    </ol>
</nav>


<div class="card">
    <div class="card-header">
        <div class="row">
            <div class="col-6">
                <h5 class="color-brand">@ViewBag.Title</h5>
            </div>
        </div>
    </div>
    <div class="card-body">
        @using (Html.BeginForm())
        {
            @Html.AntiForgeryToken()
            <div class="form-horizontal">
                @Html.ValidationSummary(true, "", new { @class = "text-danger" })
                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Role</label>
                    <div class="col-md-6">
                        @Html.EditorFor(model => model.Role, new { htmlAttributes = new { @class = "form-control" } })
                        @Html.ValidationMessageFor(model => model.Role, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Description</label>
                    <div class="col-md-6">
                        @Html.TextAreaFor(model => model.Description, new {  @class = "form-control" })
                        @Html.ValidationMessageFor(model => model.Description, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Status</label>
                    <div class="col-md-6">
                        @Html.CheckBoxFor(model => model.IsActive, new { @checked = "checked" })
                        @Res.IsActive
                        @Html.ValidationMessageFor(model => model.IsActive, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group row">
                    <div class="offset-md-2 col-md-6">
                        <input type="submit" value="@Res.Add" class="btn btn-sm btn-primary" />
                        <input type="reset" value="@Res.Reset" class="btn btn-sm btn-danger" />
                    </div>
                </div>
            </div>
        }
    </div>
</div>

FQ.MD.WEB/Views/Roles/Delete.cshtml
@model FQ.MD.WEB.ViewModels.Form.RoleDeleteForm
@using FQ.MD.WEB.Resources

@{
    ViewBag.Title = Res.Delete;
}

<nav aria-label="breadcrumb">
    <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="/"><i class="fas fa-home"></i> Dashboard</a></li>
        <li class="breadcrumb-item"><a href="@Url.Action("Index")">@Res.Roles</a></li>
        <li class="breadcrumb-item active" aria-current="page">@ViewBag.Title</li>
    </ol>
</nav>


<div class="card">
    <div class="card-header">
        <div class="row">
            <div class="col-6">
                <h5 class="color-brand">@ViewBag.Title</h5>
            </div>
        </div>
    </div>
    <div class="card-body">
        @using (Html.BeginForm())
        {
            @Html.AntiForgeryToken()
            <div class="form-horizontal">
                @Html.ValidationSummary(true, "", new { @class = "text-danger" })
                @Html.HiddenFor(model => model.RoleId)
                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Role</label>
                    <div class="col-md-6">
                        @Html.EditorFor(model => model.Role, new { htmlAttributes = new { @class = "form-control", @readonly = "readonly" } })
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Description</label>
                    <div class="col-md-6">
                        @Html.TextAreaFor(model => model.Description, new { @class = "form-control", @readonly = "readonly" })
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Remark</label>
                    <div class="col-md-6">
                        @Html.TextAreaFor(model => model.Remark, new { @class = "form-control" })
                        @Html.ValidationMessageFor(model => model.Remark, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group row">
                    <div class="offset-md-2 col-md-6">
                        <input type="submit" value="@Res.Delete" class="btn btn-sm btn-danger" />
                    </div>
                </div>
            </div>
        }
    </div>
</div>

FQ.MD.WEB/Views/Roles/Detail.cshtml
@model FQ.MD.WEB.ViewModels.RoleViewModel
@using FQ.MD.WEB.Resources

@{
    ViewBag.Title = Res.Show;
}

<nav aria-label="breadcrumb">
    <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="/"><i class="fas fa-home"></i> Dashboard</a></li>
        <li class="breadcrumb-item"><a href="@Url.Action("Index")">@Res.Roles</a></li>
        <li class="breadcrumb-item active" aria-current="page">@ViewBag.Title</li>
    </ol>
</nav>


<div class="card">
    <div class="card-header">
        <div class="row">
            <div class="col-6">
                <h5 class="color-brand">@ViewBag.Title</h5>
            </div>
        </div>
    </div>
    <div class="card-body">
        @using (Html.BeginForm())
        {
            <div class="form-horizontal">
                @Html.ValidationSummary(true, "", new { @class = "text-danger" })
                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Role</label>
                    <div class="col-md-6">
                        <label>@Model.Role</label>
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Description</label>
                    <div class="col-md-6">
                        <label>@Model.Description</label>
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Status</label>
                    <div class="col-md-6">
                        @Html.Raw(Model.Active)
                        @Res.IsActive
                    </div>
                </div>
            </div>
        }
    </div>
</div>

FQ.MD.WEB/Views/Roles/Edit.cshtml
@model FQ.MD.WEB.ViewModels.Form.RoleEditForm
@using FQ.MD.WEB.Resources

@{
    ViewBag.Title = Res.Edit;
}

<nav aria-label="breadcrumb">
    <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="/"><i class="fas fa-home"></i> Dashboard</a></li>
        <li class="breadcrumb-item"><a href="@Url.Action("Index")">@Res.Roles</a></li>
        <li class="breadcrumb-item active" aria-current="page">@ViewBag.Title</li>
    </ol>
</nav>


<div class="card">
    <div class="card-header">
        <div class="row">
            <div class="col-6">
                <h5 class="color-brand">@ViewBag.Title</h5>
            </div>
        </div>
    </div>
    <div class="card-body">
        @using (Html.BeginForm())
        {
            @Html.AntiForgeryToken()
            <div class="form-horizontal">
                @Html.ValidationSummary(true, "", new { @class = "text-danger" })
                @Html.HiddenFor(model => model.RoleId)
                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Role</label>
                    <div class="col-md-6">
                        @Html.EditorFor(model => model.Role, new { htmlAttributes = new { @class = "form-control", @readonly = "readonly" } })
                        @Html.ValidationMessageFor(model => model.Role, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Description</label>
                    <div class="col-md-6">
                        @Html.TextAreaFor(model => model.Description, new { @class = "form-control" })
                        @Html.ValidationMessageFor(model => model.Description, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Status</label>
                    <div class="col-md-6">
                        @Html.CheckBoxFor(model => model.IsActive, new { @checked = "checked" })
                        @Res.IsActive
                        @Html.ValidationMessageFor(model => model.IsActive, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group row">
                    <div class="offset-md-2 col-md-6">
                        <input type="submit" value="@Res.Edit" class="btn btn-sm btn-primary" />
                        <input type="reset" value="@Res.Reset" class="btn btn-sm btn-danger" />
                    </div>
                </div>
            </div>
        }
    </div>
</div>

FQ.MD.WEB/Views/Roles/Index.cshtml
@using FQ.MD.WEB.Resources
@{
    ViewBag.Title = Res.Roles;
}

<nav aria-label="breadcrumb">
    <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="/"><i class="fas fa-home"></i> Dashboard</a></li>
        <li class="breadcrumb-item active" aria-current="page">@ViewBag.Title</li>
    </ol>
</nav>

<div class="card">
    <div class="card-header">
        <div class="row">
            <div class="col-6">
                <h5 class="color-brand">@ViewBag.Title</h5>
            </div>
            <div class="col-6 text-right">
                @if (ViewBag.IsCreateGranted)
                {
                    <a class="btn btn-sm btn-primary" href="@Url.Action("Add")">@Res.Add</a>
                }
            </div>
        </div>
    </div>
    <div class="card-body">
        <div class="table-responsive">
            <table id="datatable" class="table table-striped" style="width:100%">
                <thead>
                    <tr>
                        <th> @Res.Role </th>
                        <th> @Res.Description </th>
                        <th> @Res.IsActive </th>
                        <th></th>
                    </tr>
                </thead>
                <tbody></tbody>
            </table>
        </div>
    </div>
</div>



@section Scripts{
    <script type="text/javascript">
        $(document).ready(function () {
            $('#datatable').DataTable({
                "bStateSave": true,
                "processing": true,
                "serverSide": true,
                "ajax": {
                    url: "@Url.Action("Index", "Roles")",
                    type: 'POST'
                },
                "language": {
                    "search": "@Res.Search",
                    "searchPlaceholder": "@Res.Keywords",
                    "lengthMenu": "@Res.Show _MENU_ @Res.Entries",
                    "zeroRecords": "@Res.NoData",
                    "info": "",
                    "infoEmpty": "@Res.NoData",
                    "infoFiltered": "",
                    "paginate": { "first": "|<", "previous": "<", "next": ">", "last": ">|"

                    }
                },
                "columns": [
                     { "data": "Role" },
                     { "data": "Description" },
                     { "data": "Active", "className": 'text-center' },
                     { "data": "Actions", "className": 'text-right', "orderable": false }
                ]
            });
        });
    </script>
}